  // Affichage des niveaux sur afficheur LCD
  // Format : "EP xxx L GOxxx L"
  //          "EG xx%   ENxx%  "
  
  char TamponAffichage[NB_COLONNES+1] ;
  
  // Conversion nombre-chaine : plus économe en pile que sprintf
  // Conversion de nombres entiers seulement, sans signe
  void Convert(char* LeTampon, int16_t Pos)
  {
    char Tampon[10];
    int32_t i = 9;
    int32_t j;
    bool Negatif = false;
    
    if ( Pos < 0 )
    {
      Negatif = true ;
      Pos = -Pos;
    }
  
    Tampon[i--] = '\0';
    
    do
    {
      Tampon[i--] = '0' + (Pos % 10);
      Pos = Pos / 10;
    } while ( (Pos > 0) && ( i >= 0 ) );
    
  //  Tampon[i] = ( Negatif ? '-' : '+' ) ; Pas de signe
    i++ ;          // pour remettre le pointeur sur le dernier chiffre généré
      
    for (j = 0 ; i<9 ; j++, i++)
      LeTampon[j] = Tampon[i];
  }
  
  void SetupAFfichage(void)
  {
    lcd.begin( NB_COLONNES, NB_LIGNES ) ;
    lcd.setCursor(0, 0) ;
    lcd.print("** Bienvenue **") ;
    lcd.setCursor(0, 1) ;
    lcd.print("IndicateurLCD..7") ;
    delay(1500);
    lcd.noCursor() ;
  }

  void ReinitAFfichage(void)
  {
    lcd.begin( NB_COLONNES, NB_LIGNES ) ;
    AffichageAttente () ;
    lcd.noCursor() ;
  }

void AffichageErreurCAN ( void )
{
  int16_t i ;

  // Vidage tampon affichage
  for ( i = 0 ; i < NB_COLONNES ; i++ )
    TamponAffichage[i] = SP ;                // Nettoyage tampon

  TamponAffichage[0] = '*' ;
  TamponAffichage[1] = '*' ;
  TamponAffichage[2] = ' ' ;
  TamponAffichage[3] = 'E' ;
  TamponAffichage[4] = 'R' ;
  TamponAffichage[5] = 'R' ;
  TamponAffichage[6] = 'E' ;
  TamponAffichage[7] = 'U' ;
  TamponAffichage[8] = 'R' ;
  TamponAffichage[9] = ' ' ;
  TamponAffichage[10] = 'C' ;
  TamponAffichage[11] = 'A' ;
  TamponAffichage[12] = 'N' ;
  TamponAffichage[13] = ' ' ;
  TamponAffichage[14] = '*' ;
  TamponAffichage[15] = '*' ;

  lcd.clear() ;
  lcd.setCursor(0, 0) ;
  lcd.print(TamponAffichage) ;

  // Vidage tampon affichage
  for ( i = 0 ; i < NB_COLONNES ; i++ )
    TamponAffichage[i] = SP ;                // Nettoyage tampon

  if ( CANErrorNiveaux )
  {
    TamponAffichage[0] = 'J' ;
    TamponAffichage[1] = 'A' ;
    TamponAffichage[2] = 'U' ;
    TamponAffichage[3] = 'G' ;
    TamponAffichage[4] = 'E' ;
  }

  if ( CANErrorNiveaux && CANErrorBMS )
  {  
    TamponAffichage[5] = ' ' ;
    TamponAffichage[6] = 'E' ;
    TamponAffichage[7] = 'T' ;
    TamponAffichage[8] = ' ' ;
  }
  
  if ( CANErrorBMS )
  {  
    TamponAffichage[9] = 'B' ;
    TamponAffichage[10] = 'M' ;
    TamponAffichage[11] = 'S' ;
  }
  
  lcd.setCursor(0, 1) ;
  lcd.print(TamponAffichage) ;
}
  
  // Fonction d'affichage des données des réservoirs
void AffichageReservoirs (void)
{
  int16_t i ;
  int32_t Pourcent ;
  
  // Vidage tampon affichage
  for ( i = 0 ; i < NB_COLONNES ; i++ )
    TamponAffichage[i] = SP ;                // Nettoyage tampon
    
  // Première ligne
  TamponAffichage[0] = 'G' ;
  TamponAffichage[1] = 'O' ;
  TamponAffichage[2] = ' ' ;

  Convert( &TamponAffichage[3], Contenus[0] ) ;

  TamponAffichage[6] = 'L' ;
  TamponAffichage[7] = ' ' ;
  TamponAffichage[8] = ' ' ;
  TamponAffichage[9] = 'E' ;
  TamponAffichage[10] = 'P' ;
  TamponAffichage[11] = ' ' ;

  Convert( &TamponAffichage[12], Contenus[1] ) ;

  TamponAffichage[15] = 'L' ;
  TamponAffichage[NB_COLONNES] = '\0' ;
  lcd.setCursor(0, 0) ;
  lcd.print(TamponAffichage) ;

  // Deuxième ligne

  // Vidage tampon affichage
  for ( i = 0 ; i < NB_COLONNES ; i++ )
    TamponAffichage[i] = SP ;                // Nettoyage tampon
  
  TamponAffichage[0] = 'E' ;
  TamponAffichage[1] = 'G' ;
  TamponAffichage[2] = ' ' ;

  Pourcent = (int32_t)Contenus[2] * 100 / CAPACITE_EAUX_GRISES ;
  Convert( &TamponAffichage[3], Pourcent ) ;

  TamponAffichage[6] = '%' ;
  TamponAffichage[7] = ' ' ;
  TamponAffichage[8] = ' ' ;
  TamponAffichage[9] = 'E' ;
  TamponAffichage[10] = 'N' ;
  TamponAffichage[11] = ' ' ;

  Pourcent = (int32_t)Contenus[3] * 100 / CAPACITE_EAUX_NOIRES ;
  Convert( &TamponAffichage[12], Pourcent ) ;

  TamponAffichage[15] = '%' ;
  TamponAffichage[NB_COLONNES] = '\0' ;
  lcd.setCursor(0, 1) ;
  lcd.print(TamponAffichage) ;
}

void AffichageBatterie ( void )
{
  int16_t i ;

  // Vidage tampon affichage
  for ( i = 0 ; i < NB_COLONNES ; i++ )
    TamponAffichage[i] = SP ;                // Nettoyage tampon
    
  // Première ligne
  TamponAffichage[0] = 'B' ;
  TamponAffichage[1] = 'A' ;
  TamponAffichage[2] = 'T' ;
  TamponAffichage[3] = ' ' ;

  Convert( &TamponAffichage[4], SOCx10P / 10 ) ;

  TamponAffichage[7] = '%' ;
  TamponAffichage[8] = SP ;
  TamponAffichage[9] = '(' ;


  Convert( &TamponAffichage[10], SOCx10 / 10 ) ;

  TamponAffichage[13] = '%' ;
  TamponAffichage[14] = ')' ;

  lcd.setCursor(0, 0) ;
  lcd.print(TamponAffichage) ;

  // Vidage tampon affichage
  for ( i = 0 ; i < NB_COLONNES ; i++ )
    TamponAffichage[i] = SP ;                // Nettoyage tampon

  TamponAffichage[0] = 'T' ;
  TamponAffichage[1] = 'E' ;
  TamponAffichage[2] = 'M' ;
  TamponAffichage[3] = 'P' ;
  TamponAffichage[4] = ' ' ;
       
  Convert( &TamponAffichage[5], TemperatureBatterie / 10 ) ;
  TamponAffichage[8] = 'D' ;
  TamponAffichage[9] = 'E' ;
  TamponAffichage[10] = 'G' ;

  lcd.setCursor(0, 1) ;
  lcd.print(TamponAffichage) ;
}

void AffichageAttente ( void )
{
  lcd.setCursor(0, 0) ;
  lcd.print("**  Jaugeage  **") ;
  lcd.setCursor(0, 1) ;
  lcd.print("**  en cours  **") ;
}
  
void Affichage ( void )
{
  if ( DiviseurAttente > 0 )
    AffichageAttente () ;
  else
  {
    Clignoteur = ! Clignoteur ;
    if ( Clignoteur )
    {
      if ( CANErrorNiveaux )
        AffichageErreurCAN () ;
      else
        AffichageReservoirs() ;
    }    
    else
    {
      if ( CANErrorBMS )
        AffichageErreurCAN () ;
      else
        AffichageBatterie() ;
    }
  }
}
